#ifndef MYLIB_INCLUDE
#define MYLIB_INCLUDE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <piece.h>
#include"windef.h"
extern int errno;
//

//
#define SYSTEM_MEMORY_ALLOC 0
#if SYSTEM_MEMORY_ALLOC
#define	Malloc	malloc
#define	Free	free
#else
#define	Malloc	pceHeapAlloc
#define	Free 	pceHeapFree
#endif
//
//OtBbNn
void Line(int x1,int y1,int x2,int y2,int c);
void BoxFill(int x1,int y1,int x2,int y2,int c);
void Pset(int x,int y,int c);
unsigned int Pget(int x,int y,int c);
void BoxFillRev(int x1,int y1,int x2,int y2,int c);
void Line2(int x1,int y1,int x2,int y2,int c);
void Box(int x1,int y1,int x2,int y2,int c);
void DrawText(char* text,int x,int y);
void SetTextColor(int cfor,int cback);
void PutKanji(int dx,int dy,int ch,int color);
void PutGData(unsigned char* data,int width,int height,int bit);
//VXen

void SetActiveWindow(HWND hwnd);
int SetNextActiveWindow();
HWND CreateWindow(char *ClassName,char* TitleName,DWORD Style,int x,int y,int width,int height,HWND hwndParent);
void DestroyWindow(HWND hwnd);
int SearchWindowNum(HWND hwnd);
void UpdateWindow(HWND hwnd);
int SendMessage(HWND hwnd,int message,int param1,int param2);
void PostMessage(HWND hwnd,int message,int param1,int param2);
void SetRegister(char* title,void* proc);
void PostQuitMessage(int code);
void DefWndProc(HWND hwnd,int message,int param1,int param2);
void PopMessage();
LPSTR GetTextXY(LPSTR text,int x,int y);
//
int IsHandle(HWND hwnd);
void SetWindowText(HWND hwnd,char* title);
void SetWindowText2(HWND hwnd,char* title);
int GetWindowText(HWND hwnd,char* title,int size);
void ShowWindow(HWND hwnd,int flag);
//
#define	wsprintf sprintf
int MessageBox(char* mes,char* var,int button);
int MessageBoxDebug(char* mes,char* var,int button);
void KeyClear();
void CopyMemory(void* buf1,void* buf2,int size);
void ZeroMemory(void* buf,int size);
void MoveMemory(void* buf1,void* buf2,int size);
void FillMemory(void* buf,int size,char fill);
#define STR_MYLIB 1
#if STR_MYLIB==1
int Strlen(char* s);
char* Strcpy(char* d,char* s);
char* Strcat(char* d,char* s);
int Strcmp(char* d,char* s);
#define		strlen	Strlen
#define		strcpy	Strcpy
#define		strcat	Strcat
#define		strcmp	Strcmp
#endif
//
#endif
