/*{Iȏ*/
#include"mylib.h"
int Strlen(char* s)
{
	int len=0;
	if(s==NULL)
		return 0;
	if(*s==0)
		return 0;
	while(*s){
		if(*s)
			++len;
		s++;
	}
	return len;
}
char* Strcpy(char* d,char* s)
{
	if(d==NULL)
		return NULL;
	if(s==NULL){
		*d=0;
		return d;
	}
	while(*s){
		*d++=*s++;
	}
	*d=0;
	return d;
}
char* Strcat(char* d,char* s)
{
	if(d==NULL)
		return NULL;
	if(s==NULL){
		return d;
	}
	while(*d){
		d++;
	}
	while(*s){
		*d++=*s++;
	}
	*d=0;
	return d;
}
int Strcmp(char* d,char* s)
{//̂ǂ̔̂
	int len1,len2,a,count;
	if(d==NULL)
		return -1;
	if(s==NULL){
		return -1;
	}
	len1=Strlen(s);
	len2=Strlen(d);
	if(len1!=len2)
		return 1;
	count=0;
	for(a=0;a<len1;++a){
		if(d[a]==s[a])
			++count;
	}
	if(count==len1)
		return 0;
	else
		return 1;
}
void ZeroMemory(void* buf,int size)
{
	int a;
	char *buf1=(char*)buf;
	for(a=0;a<size;++a)
		*buf1++=0;
}
void FillMemory(void* buf,int size,char fill)
{
	int a;
	char *buf1=(char*)buf;
	for(a=0;a<size;++a)
		*buf1++=fill;
}
void CopyMemory(void* buf1,void* buf2,int size)
{
	int a;
	char *buf1c=(char*)buf1;
	char *buf2c=(char*)buf2;
	for(a=0;a<size;++a)
		*buf1c++=*buf2c++;
}
void MoveMemory(void* buf1,void* buf2,int size)
{
	int a;
	char *buf1c=(char*)buf1;
	char *buf2c=(char*)buf2;
	if(buf1c<=buf2c){
		for(a=0;a<size;++a)
			*buf1c++=*buf2c++;
	}else{
		size--;
		buf1c+=size;
		buf2c+=size;
		for(a=0;a<=size;++a)
			*buf1c--=*buf2c--;
	}
}
/*********************************/
void PostQuitMessage(int code)
{
	pceAppReqExit(code);
}
void KeyClear()
{
	while(pcePadGet())
		pcePadGetProc();
}
int MessageBox(char* mes,char* var,int button)
{
	int len,w,h,k,result,btlen;
	int y,my,a,b,c;
	unsigned char text[30];
	char *m,*bt;
	len=Strlen(mes);
	if(len==0)
		return 0;
	KeyClear();
	switch(button){
		case MB_OKCANCEL:
			bt="[A:OK][C:CANCEL]";
			break;
		case MB_YESNO:
			bt="[A:YES][B:NO]";
			break;
		case MB_YESNOCANCEL:
			bt="[A:YES][B:NO][C:CANCEL]";
			break;
		case MB_CANCEL:
			bt="[C:CANCEL]";
			break;
		case MB_OK:
		default:
			bt="[A:OK]";
			break;
	}
	btlen=(Strlen(bt)*5)/2;
	my=1+(len/24);
	if(my>6)	my=6;
	if(my>1)	len=24;
	h=25+my*10;
	y=44-(h/2);
	w=(len/2)*5;
	if(w<20)	w=20;
	if(w<btlen)	w=btlen;
	BoxFill(60-w,y,64+w+4,y+h,0);
	BoxFill(60-w,y,64+w+4,y+11,2);
	Box(60-w,y,64+w+4,y+h,3);
	pceFontSetTxColor(0);pceFontSetBkColor(2);
	pceFontSetPos( 64-w, y+1);
	pceFontPrintf(var);
	pceFontSetTxColor(3);pceFontSetBkColor(0);
	//
	m=mes;
	for(a=0;a<my;++a){
		pceFontSetPos( 62-w, y+12+a*10);
		for(b=0;b<24 && *m!=0;++b){
			text[b]=*m++;
		}
		text[b]=text[b+1]=0;
		c=text[b-1];
		if(*m){
			if((c>=0x80 && c<=0x9f) || (c>=0xe0 && c<=0xff)){
				m--;
				text[b-1]=0;
			}
		}
		pceFontPrintf(text);
	}
	pceFontSetPos( 64-w, y+h-10);
	pceFontPrintf(bt);
	result=0;
	pceLCDTrans();
	for(;;){
		pcePadGetProc();
		k=pcePadGet();
		if((k & PAD_A) && button & MB_OK){
			result=IDOK;break;
		}
		if((k & PAD_C) && button & MB_CANCEL){
			result=IDCANCEL;break;
		}
		if((k & PAD_A) && button & MB_YESNO){
			result=IDYES;break;
		}
		if((k & PAD_B) && button & MB_YESNO){
			result=IDNO;break;
		}
	}
//	pceFontSetPos( 0,0);
//	pceFontPrintf(mes);
	KeyClear();
	BoxFill(0,0,127,87,0);
	SendMessage(NULL,WM_PAINT,-1,0);
	return result;
}
int MessageBoxDebug(char* mes,char* var,int button)
{
	int len,w,h,k,result,btlen;
	int y,my,a,b,c;
	unsigned char text[30];
	char *m,*bt;
	len=strlen(mes);
	if(len==0)
		return 0;
	KeyClear();
	switch(button){
		case MB_OKCANCEL:
			bt="[A:OK][C:CANCEL]";
			break;
		case MB_YESNO:
			bt="[A:YES][B:NO]";
			break;
		case MB_YESNOCANCEL:
			bt="[A:YES][B:NO][C:CANCEL]";
			break;
		case MB_CANCEL:
			bt="[C:CANCEL]";
			break;
		case MB_OK:
		default:
			bt="[A:OK]";
			break;
	}
	btlen=(strlen(bt)*5)/2;
	my=1+(len/24);
	if(my>6)	my=6;
	if(my>1)	len=24;
	h=25+my*10;
	y=44-(h/2);
	w=(len/2)*5;
	if(w<20)	w=20;
	if(w<btlen)	w=btlen;
	BoxFill(60-w,y,64+w+4,y+h,0);
	BoxFill(60-w,y,64+w+4,y+11,2);
	Box(60-w,y,64+w+4,y+h,3);
	pceFontSetTxColor(0);pceFontSetBkColor(2);
	pceFontSetPos( 64-w, y+1);
	pceFontPrintf(var);
	pceFontSetTxColor(3);pceFontSetBkColor(0);
	//
	m=mes;
	for(a=0;a<my;++a){
		pceFontSetPos( 62-w, y+12+a*10);
		for(b=0;b<24 && *m!=0;++b){
			text[b]=*m++;
		}
		text[b]=text[b+1]=0;
		c=text[b-1];
		if(*m){
			if((c>=0x80 && c<=0x9f) || (c>=0xe0 && c<=0xff)){
				m--;
				text[b-1]=0;
			}
		}
		pceFontPrintf(text);
	}
	pceFontSetPos( 64-w, y+h-10);
	
	pceFontPrintf(bt);
	result=0;
	pceLCDTrans();
	for(;;){
		pcePadGetProc();
		k=pcePadGet();
		if((k & PAD_A) && button & MB_OK){
			result=IDOK;break;
		}
		if((k & PAD_C) && button & MB_CANCEL){
			result=IDCANCEL;break;
		}
		if((k & PAD_A) && button & MB_YESNO){
			result=IDYES;break;
		}
		if((k & PAD_B) && button & MB_YESNO){
			result=IDNO;break;
		}
	}
	KeyClear();
	BoxFill(0,0,127,87,0);
//	SendMessage(NULL,WM_PAINT,-1,0);
	return result;
}
